"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_display_name_1 = __importDefault(require("react-display-name"));
var react_1 = require("@testing-library/react");
var makeNoop = function (name) {
    var noop = function () { return React.createElement("div", { "data-jest-mock-react-noop": name }); };
    noop.displayName = name;
    return noop;
};
var jestMockReactNoop = function (fn, react) {
    if (react === void 0) { react = jest.requireActual("react"); }
    return (__assign(__assign({}, react), { createElement: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var type = args[0];
            var name = react_display_name_1.default(type);
            if (typeof type !== 'string') {
                var matches = void 0;
                if (typeof fn === 'string') {
                    matches = fn === name;
                }
                else if (fn instanceof RegExp) {
                    matches = fn.test(name);
                }
                else if (typeof fn === 'function') {
                    matches = fn(name, type);
                }
                if (!matches) {
                    return react.createElement(makeNoop(name));
                }
            }
            return react.createElement.apply(react, args);
        } }));
};
exports.jestMockReactNoop = jestMockReactNoop;
var makeQueryByNoop = function (container) { return function (name) {
    return container.querySelector("[data-jest-mock-react-noop=\"" + name + "\"]");
}; };
var makeQueryAllByNoop = function (container) { return function (name) {
    return Array.from(container.querySelectorAll("[data-jest-mock-react-noop=\"" + name + "\"]"));
}; };
var queryByNoop = function (container, name) { return makeQueryByNoop(container)(name); };
var queryAllByNoop = function (container, name) { return makeQueryAllByNoop(container)(name); };
var makeGetByNoop = function (container) { return function (name) {
    var _a, _b;
    var selector = "[data-jest-mock-react-noop=\"" + name + "\"]";
    var elements = container.querySelectorAll(selector);
    if (((_a = elements) === null || _a === void 0 ? void 0 : _a.length) === 0) {
        throw new Error("Unable to find an element by: " + selector);
    }
    if (((_b = elements) === null || _b === void 0 ? void 0 : _b.length) > 1) {
        throw new Error("Found multiple elements by: " + selector);
    }
    return elements[0];
}; };
var makeGetAllByNoop = function (container) { return function (name) {
    var _a;
    var selector = "[data-jest-mock-react-noop=\"" + name + "\"]";
    var elements = container.querySelectorAll(selector);
    if (((_a = elements) === null || _a === void 0 ? void 0 : _a.length) === 0) {
        throw new Error("Unable to find an element by: " + selector);
    }
    return Array.from(elements);
}; };
var getByNoop = function (container, name) { return makeGetByNoop(container)(name); };
var getAllByNoop = function (container, name) { return makeGetAllByNoop(container)(name); };
var noopQueries = {
    queryByNoop: queryByNoop,
    queryAllByNoop: queryAllByNoop,
    getByNoop: getByNoop,
    getAllByNoop: getAllByNoop
};
exports.noopQueries = noopQueries;
var noopQueriesWithDefaults = __assign(__assign({}, react_1.queries), noopQueries);
exports.noopQueriesWithDefaults = noopQueriesWithDefaults;
var renderWithNoop = function (ui, options) { return react_1.render(ui, __assign(__assign({}, options), { queries: __assign(__assign({}, noopQueriesWithDefaults), (options ? options.queries : undefined)) })); };
exports.renderWithNoop = renderWithNoop;
exports.default = jestMockReactNoop;
